
var fadeFontSize = 16;

document.onreadystatechange = function()
{
	if(document.readyState == "complete")
	{
		try 
		{
			// Gadget code
			System.Gadget.settingsUI = "settings.html";
			System.Gadget.onSettingsClosed = SettingsClosed;
		}
		catch(err)
		{
		}
		init();
	}
}

function init()
{
     dockStateChanged();
}

// Declare the dock and undock event handlers.
System.Gadget.onDock = dockStateChanged;
System.Gadget.onUndock = dockStateChanged;

// called when the docked state changes
function dockStateChanged()
{
	var root = document.getElementById("rootdiv");
	//Remove all child nodes (icons)
	if ( root.hasChildNodes() )
    {
        while ( root.firstChild )
        {
            root.removeChild(root.firstChild);       
        } 
    }
    
    var layout = parseInt(getSetting('LayoutStyle',defaultLayoutStyle)); 
    
    //When docked always use default layout and sizes
    var originalIconSize = getSetting("IconSize",defaultIconSize);
    if(System.Gadget.docked)
    {
        layout = defaultLayoutStyle;
        setSetting("IconSize",defaultIconSize);
    }
    
    GenerateLinks(layout,root,getSetting('ShortcutPath',defaultShortcutPath)); 
    setSize(layout);
    
    //Revert to user-selected state
    setSetting("IconSize",originalIconSize);
}

function setSize(layout)
{
    //When docked layout is set to default and the number of icons are limited...

    var folderWidth = foldercount*(parseInt(getSetting('IconSize',defaultIconSize))+2*parseInt(getSetting('IconMargin',defaultIconMargin)));
    var fileWidth = maxLinkCountInFolder*(parseInt(getSetting('IconSize',defaultIconSize))+2*parseInt(getSetting('IconMargin',defaultIconMargin)));
      
    //Vertical icons
    if(layout == 1 || layout == 2 || layout == 5 || layout == 6) //Vertical
    {
        document.body.style.width = folderWidth+"px";
        document.body.style.height = fileWidth+"px";
        document.getElementById("rootdiv").style.width = folderWidth+"px";
        document.getElementById("rootdiv").style.height = fileWidth+"px";
                     
    }
    //Horizontal Icons
    else if(layout < 9)
    {
        document.body.style.width = fileWidth+"px";
        document.body.style.height = folderWidth+"px";     
        document.getElementById("rootdiv").style.width = fileWidth+"px";
        document.getElementById("rootdiv").style.height = folderWidth+"px";   
    }  
    //Text layouts
    else
    {
        document.body.style.width = "500px";
        document.body.style.height = screen.height; 
    } 
}

var filesystem  = new ActiveXObject("Scripting.FileSystemObject"); 
var maxLinkCountInFolder;
var linkcount;
var foldercount;

//shortcutfolder contains the shortcut files
function GenerateLinks(layout,element,shortcutfolder)
{
    maxLinkCountInFolder = 0;
    linkcount = 0;
    foldercount = 0;
 
	var folder = filesystem.GetFolder(shortcutfolder);
	
	//Text layouts 9 and 10
    if(layout == 9 || layout == 10)
    {
        //folder tree
        var rootul = document.createElement("ul");
        rootul.id = "foldingtree1";
        rootul.className = "treeview";
        rootul.style.backgroundColor = "Black";
        rootul.style.width = "150px";
        //Add content...
        renderFolder_Text(layout,rootul,folder);        
        
        //Expand/Contract all
        var expandLink = document.createElement('a');
        expandLink.href = "javascript:ddtreemenu.flatten('foldingtree1', 'expand')";
        var expandText = document.createElement('font');
        expandText.innerText = "Expand all";
        expandText.style.paddingLeft = "10px";
        expandLink.appendChild(expandText);
        var contractLink = document.createElement('a');
        contractLink.href = "javascript:ddtreemenu.flatten('foldingtree1', 'contract')";
        var contractText = document.createElement('font');
        contractText.innerText = "Contract all";
        contractText.style.paddingLeft = "3px";
        contractLink.appendChild(contractText);
        var expandDiv = document.createElement('div');
        expandDiv.style.width = "150px";
        expandDiv.style.backgroundColor = "Black";
        expandDiv.appendChild(expandLink);
        expandDiv.appendChild(contractLink);
        
        //Add elements
        element.appendChild(expandDiv);
        element.appendChild(rootul);

        //   1. 1st parameter is the ID of the list to transform.
        //   2. 2nd parameter is a Boolean value (true of false) indicating whether you want persistence to be enabled.
        //   3. 3rd parameter is the number of days to persist menu state assuming persistence is enabled. This last parameter is optional, and if omitted, defaults to 1 (day).
        //   see: http://www.dynamicdrive.com/dynamicindex1/navigate1.htm
        ddtreemenu.createTree('foldingtree1', false);
        ddtreemenu.flatten('foldingtree1', 'contract');

    }
    else //Icon layouts
    {
        //Loop trough folders   
	    var subFolders  = new Enumerator(folder.SubFolders);
	    if(folder.subFolders.count != 0)
	    {
		    while(! subFolders.atEnd())
		    {
                linkcount = renderFolder_Icon(layout,element,subFolders.item(),0);
                if(linkcount> maxLinkCountInFolder)
                    maxLinkCountInFolder = linkcount;
                if(linkcount> 0)
                    foldercount++;
                //Only 9 shortcuts must be generated when docked (in order to avoid flickering)
                if(System.Gadget.docked && foldercount >= 3)
                    break;
		        subFolders.moveNext();
		    }
        }
        
        //Only 9 shortcuts must be generated when docked (in order to avoid flickering)
        if( ! (System.Gadget.docked && foldercount >= 3))
        {
            //Root folder in the end...
            linkcount = renderFolder_Icon(layout,element,folder,1);
            if(linkcount> maxLinkCountInFolder)
                maxLinkCountInFolder = linkcount;
            if(linkcount> 0)
                foldercount++;
        }
                     
        if(layout == 5) //"Up"
        {
            //Align shortcuts
            document.getElementById("rootdiv").style.position= "absolute";
            var fileWidthPopup = (maxLinkCountInFolder-1)*(parseInt(getSetting('IconSize',defaultIconSize))+2*parseInt(getSetting('IconMargin',defaultIconMargin)));
            document.getElementById("rootdiv").style.top = fileWidthPopup+"px";   
            document.getElementById("rootdiv").style.left = "0px";    
        } 
        else // All other than "Up"...must be reset
        {
            document.getElementById("rootdiv").style.position= "relative";
            document.getElementById("rootdiv").style.top = "0px";
        }  
    }   
    
    //Alignment inside div              
    if (layout == 8 || layout == 3) //"Pop-left" or "Static right-aligned"
        document.getElementById("rootdiv").align = "Right";    
    else
        document.getElementById("rootdiv").align = "Left";
}
	
function renderFolder_Icon(layout,element,folder,skipFolders)
{
	//alert('render folder '+ folder);
	var links = 0;
    //Loop trough files
    var files  = new Enumerator(folder.Files);
    var folders  = new Enumerator(folder.SubFolders);	
	//Any files og subfolders?
	if(folder.Files.count != 0 || folder.SubFolders.count != 0)
	{
	    var rowdiv = document.createElement('div');
	    
	    //Static layouts
	    if(layout <= 4)
	    {  
            //Static layouts
            if(layout == 1) //Static top-aligned
            {
                rowdiv.style.display = "inline";
                rowdiv.style.verticalAlign = "top";
                rowdiv.style.width = getSetting("IconSize",defaultIconSize)+"px";
            }
            else if(layout == 2) //Static bottom-aligned
            {
                rowdiv.style.display = "inline";
                rowdiv.style.verticalAlign = "bottom";
                rowdiv.style.width = getSetting("IconSize",defaultIconSize)+"px";
            }
                        
            //Render HTML for all the links
	        //First level sub-Folders
	        if(! skipFolders)
	        {
	            while(! folders.atEnd())
	            {
	                if(renderLink(layout,rowdiv,folders.item()))
			    	    links++;
		            folders.moveNext();
		            //Only 9 shortcuts must be generated when docked (in order to avoid flickering)
                    if(System.Gadget.docked && links >= 3)
                        break;          
	            }
	        }
	        //Files
	        while(! files.atEnd())
	        {
               	if(renderLink(layout,rowdiv,files.item()))
			    	links++;
		        files.moveNext();
		        //Only 9 shortcuts must be generated when docked (in order to avoid flickering)
                if(System.Gadget.docked && links >= 3)
                    break;                
	        }
        }
        else if(layout > 4 && layout <= 8) //Pop-out layouts
        {
        	var divWidth = parseInt(getSetting("IconSize",defaultIconSize))+parseInt(getSetting("IconMargin",defaultIconMargin));
                    
            //Render HTML for the first link and the dropdown
	        var parentDIV = document.createElement('div');
            parentDIV.id = "menu_parent_"+folder.Name;
            parentDIV.style.position = "relative";            
            //create child div
            var childDIV = document.createElement('div');
            childDIV.id = "menu_child_"+folder.Name;
            childDIV.style.position = "absolute";
            childDIV.style.visibility = "hidden";  
            
            //First link goes into the parent div
            var destinationElement = parentDIV;            
	        //First level sub-Folders
	        if(! skipFolders)
	        {
	            while(! folders.atEnd())
	            {
	                if(renderLink(layout,destinationElement,folders.item()))
			    	    links++;
		            folders.moveNext(); 
				    if(links > 0 && destinationElement != childDIV)
				        destinationElement = childDIV;      
	            }
	        }            
            //Files
            while(! files.atEnd())
		    {
                if(renderLink(layout,destinationElement,files.item()))
	            	links++;
				files.moveNext();
				if(links > 0 && destinationElement != childDIV)
				    destinationElement = childDIV;
		    }      
    		    		
            if(layout == 5 || layout == 6) //Pop-up and Pop-down
            {
                childDIV.style.width =  divWidth+"px";
                rowdiv.style.display = "inline";          
                rowdiv.style.width =  divWidth+"px";
                parentDIV.style.width =  divWidth+"px";
                             
                //Attach popup
                at_attach(parentDIV, childDIV, "hover", layout, "pointer");
            }
            else //Pop-right (7) and Pop-left(8)
            {
                childDIV.style.height =  divWidth+"px";
                childDIV.style.width =  ((links)*divWidth)+"px"; //should be (links-1), but that is somehow too small...!          
                rowdiv.style.height =  divWidth+"px";
                rowdiv.style.width =  divWidth+"px";
                parentDIV.style.height =  divWidth+"px"; 
                                
                //Attach popup
                at_attach(parentDIV, childDIV, "hover", layout, "pointer");
            }   
		    //Append elements
		    rowdiv.appendChild(parentDIV);
		    rowdiv.appendChild(childDIV);
        }

		//Add folder only if it contained files or valid links!
		if(links > 0)
		{
            //Drag-and-drop support
            addDragDropSupport(rowdiv,folder.path);
            //Add links
        	element.appendChild(rowdiv);
		}
	}
	return links;
}

function renderFolder_Text(layout,element,folder)
{
	var folders  = new Enumerator(folder.SubFolders);
	
	var li,ul,img,text;

	while(! folders.atEnd())
	{
		li = document.createElement('li');		
	    //Icon
	    img = document.createElement('img');
	    img.src = "images/closed.gif";
        img.style.marginRight = getSetting("IconMargin",defaultIconMargin);
	    li.appendChild(img);
		//Title
		text = document.createElement('font');
		text.innerText = folders.item().Name;
		li.appendChild(text);
        //Subfolder	
		ul = document.createElement('ul');
		li.appendChild(ul);
		
        //Drag-and-drop support
        addDragDropSupport(li,folders.item().path);
		
		element.appendChild(li);
		renderFolder_Text(layout,ul,folders.item());

		folders.moveNext();
	}
	renderFilesText(layout,element,folder);
}

function renderFilesText(layout,element,folder)
{
	//Iterate through folders
	var files  = new Enumerator(folder.Files);
	var li;

	while(! files.atEnd())
	{		
		li = document.createElement('li');
	    var linkRendered = renderLink(layout,li,files.item());
		if(linkRendered)
		    element.appendChild(li);
		files.moveNext();
	}
}

function renderLink(layout,element,target)
{
    var isFolder = false;	
	if(fso.FolderExists(target))
	    isFolder = true;
	    
	//If it is a shortcuttarget and the target does not exist, we do not render a link...
	if(fso.GetExtensionName(target).toLowerCase() == 'lnk' && ! shortCutTargetExists(target))
	   return false;
	   
    var a = document.createElement('a');
    a.target="_self";
    a.href="#";
    if(isFolder)
        a.onclick=function(){FollowLink(encodeURI(target));};
    else
        a.onclick=function(){FollowLink(encodeURI(target));};
    a.className = "iconlink";
    
    var name;
    if(isFolder)
        name = target.Name;
    else
        name = target.Name.substring(0,target.Name.length-4); //remove file extension
	   
	// Icon link (no icons in folding tree layout 9)
    if(layout != 9)
    {
        var img = document.createElement('img');
        img.className = "appicon";
        
        if(getSetting("ShowTitle",defaultShowTitle) == "2")
        {
            img.onmouseover= function(){showPopup(name);};
            img.onmouseout= function(){hidePopup()};
        }
        img.style.msInterpolationMode = "bicubic";
        
        if(layout == 10)
            img.style.marginRight = getSetting("IconMargin",defaultIconMargin);
        else
            img.style.margin = getSetting("IconMargin",defaultIconMargin);
        
        img.src = 'gimage:///'+ target.path+'?width='+getSetting("IconSize",defaultIconSize)+'&height='+getSetting("IconSize",defaultIconSize);
                               
	    //Needed to eliminate space beneath image in IE !!
	    if(layout == 1 || layout == 2)
		    img.style.verticalAlign = "bottom";
               
        a.appendChild(img);
    }
    
    //Text link
    if(layout == 9 || layout == 10)
    {
        var text = document.createElement('font');
        text.innerText = name;
        a.appendChild(text);
    }
            
    element.appendChild(a);
	return true;
}

function addDragDropSupport(element,destinationPath)
{
    element.setAttribute("destinationPath",destinationPath);
    element.ondragenter = dragEnter;
    element.ondragover = dragOver;
    element.ondragleave = dragLeave;
    element.ondrop = dropItems;
}

function dragEnter()
{
    markEventElement(findRowElement());
    event.returnValue=false;
}

function dragOver()
{
    markEventElement(findRowElement());
    event.returnValue=false;
}


function dragLeave()
{
    unmarkEventElement(findRowElement());
    event.returnValue=false;
}

function markEventElement(element)
{
    element.style.backgroundColor = "#ffffff";
    element.style.color = "#000000";
}

function unmarkEventElement(element)
{
    element.style.backgroundColor = "Transparent";
    element.style.color = "#ffffff";
}

function dropItems()
{ 
    destinationFolder = findRowElement().destinationPath;    

    var draggedObjectPath;
    //Loop through dragged files and folders and move them
    for (var i=0 ; System.Shell.itemFromFileDrop(event.dataTransfer, i) != null ; i++)
    {
        draggedObjectPath = System.Shell.itemFromFileDrop(event.dataTransfer, i).path;
        if (filesystem.FolderExists(draggedObjectPath)) //Its a folder
        {
            //Movefolder
            filesystem.MoveFolder(draggedObjectPath, destinationFolder+"\\");
            init();
        }
        else //Its a file
        {
            //Move file
            filesystem.MoveFile(draggedObjectPath, destinationFolder+"\\");
            init();
        }
    }
}

function findRowElement()
{
    var layout = parseInt(getSetting('LayoutStyle',defaultLayoutStyle)); 
    var rowElement = event.srcElement;
    while( ! rowElement.destinationPath)
        rowElement = rowElement.parentNode;
    return rowElement;
}

function shortCutTargetExists(file)
{
	oLink = shell.CreateShortcut(file);		
	return fso.FileExists(oLink.TargetPath) || fso.FolderExists(oLink.TargetPath);
}

function FollowLink(fpath)
{
	fpath = decodeURI(fpath);
	if(fso.FileExists(fpath) || fso.FolderExists(fpath))
	{
		try
		{
			// Gadget code
			System.Shell.execute(fpath);
			event.returnValue = false;
			return false;
		} catch(err) { alert("Error while following Link: " +err.name +" - "+ err.message)}
	}
}

function SettingsClosed(event) {
    // User hits OK on the settings page.
    if (event.closeAction == event.Action.commit)
    {
		init();
    }
    // User hits Cancel on the settings page.
    else if (event.closeAction == event.Action.cancel)
    {
    	
    }
}