

//Updates other fields from selection of layout type
function updateLayoutSelection()
{
    var dropdownIndex = document.getElementById('LayoutStyle').selectedIndex;
    var selectedStyle = document.getElementById('LayoutStyle')[dropdownIndex].value;
    
    if(selectedStyle == 10) //Text and icons layout
    {
        document.getElementById("IconSize").value = 18;
    }
    else if(document.getElementById("IconSize").value < 32)
        document.getElementById("IconSize").value = 32;        
}

document.onreadystatechange = function()
{
	 if(document.readyState == "complete")
	 {
		readValues();
		
		document.getElementById('reset').onclick = function()
		{
		    setDefaults();			
		}
		document.getElementById('browse').onclick = function()
		{
            oFolder = shellApp.BrowseForFolder(0, "Select the folder containing your shortcuts", 0);
            if (oFolder != null)
            {
	    		var objFolderItem = oFolder.self;
		    	document.getElementById('ShortcutPath').value = objFolderItem.path;
            }
	    }

		document.getElementById('openFolder').onclick = function()
		{
			try
			{
				// Gadget code
				System.Shell.execute("explorer.exe", document.getElementById('ShortcutPath').value);
			} catch(err) { alert("Error while following Link: " +err.name +" - "+ err.message)}
		}

		try
		{
			// Gadget code
			System.Gadget.onSettingsClosing = SettingsClosing;
		} catch(err) { alert(err) }	
	}
}

function setDefaults()
{
    // Path
	document.getElementById('ShortcutPath').value = defaultShortcutPath;
	// LayoutStyle
	setSelectedValue(document.getElementById("LayoutStyle"),defaultLayoutStyle);
	// Show title
	setSelectedValue(document.getElementById("ShowTitle"),defaultShowTitle);
	// Show title color
	setSelectedValue(document.getElementById("ShowTitleColor"),defaultShowTitleColor);
	// DropdownTimeout
	document.getElementById("DropdownTimeout").value = defaultDropdownTimeout;
	// IconSize
	document.getElementById("IconSize").value = defaultIconSize;	
	//IconMargin
	document.getElementById("IconMargin").value = defaultIconMargin;
}

function readValues()
{
	// Path
	document.getElementById('ShortcutPath').value = getSetting('ShortcutPath', defaultShortcutPath);
	// LayoutStyle
	setSelectedValue(document.getElementById("LayoutStyle"),getSetting('LayoutStyle', defaultLayoutStyle));
	// ShowTitle
	setSelectedValue(document.getElementById("ShowTitle"),getSetting('ShowTitle', defaultShowTitle));
	// ShowTitleColor
	setSelectedValue(document.getElementById("ShowTitleColor"),getSetting('ShowTitleColor', defaultShowTitleColor));
	// DropdownTimeout
	document.getElementById("DropdownTimeout").value = getSetting('DropdownTimeout', defaultDropdownTimeout);
	// IconSize
	document.getElementById("IconSize").value = getSetting('IconSize', defaultIconSize);	
	//IconMargin
	document.getElementById("IconMargin").value = getSetting('IconMargin', defaultIconMargin);
}

function SettingsClosing(event) {
    if (event.closeAction == event.Action.commit) {
        //Path
        System.Gadget.Settings.write("ShortcutPath", document.getElementById('ShortcutPath').value);
        //LayoutStyle
	    var dropdownIndex = document.getElementById('LayoutStyle').selectedIndex;
	    var selectedStyle = document.getElementById('LayoutStyle')[dropdownIndex].value;
        System.Gadget.Settings.write("LayoutStyle", selectedStyle);
        //ShowTitle
	    var dropdownIndex2 = document.getElementById('ShowTitle').selectedIndex;
	    var selected = document.getElementById('ShowTitle')[dropdownIndex2].value;
        System.Gadget.Settings.write("ShowTitle", selected);
        //ShowTitleColor
	    var dropdownIndex3 = document.getElementById('ShowTitleColor').selectedIndex;
	    var selected2 = document.getElementById('ShowTitleColor')[dropdownIndex3].value;
        System.Gadget.Settings.write("ShowTitleColor", selected2);
        //DropdownTimeout
        System.Gadget.Settings.write("DropdownTimeout", document.getElementById('DropdownTimeout').value);
        //IconSize - test if it is valid number...
        var IconSizeValue = document.getElementById('IconSize').value
        if(isNaN(IconSizeValue) || IconSizeValue<0 || IconSizeValue>512)
            IconSizeValue = defaultIconSize;
        System.Gadget.Settings.write("IconSize", IconSizeValue);
        //IconMargin - test if it is valid number...   
        var IconMarginValue = document.getElementById('IconMargin').value
        if(isNaN(IconMarginValue) || IconMarginValue<0 || IconMarginValue>100)
            IconMarginValue = defaultIconMargin;
        System.Gadget.Settings.write("IconMargin", IconMarginValue);
    }
    event.cancel = false;
}

function setSelectedValue(selectList,value)
{
	for(var i=0;i<selectList.length;i++)
	{
	    if(selectList.options(i).value == value)
	    {
	        selectList.selectedIndex = i;
	        break;
	    }	        
	}
}